
%global meadversion 1.0.1
%global namedversion 1.0.1.Final-redhat-2
%global meadalpha .Final_redhat_2
%global meadrel .2
%global serial 4

# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%bcond_with javadoc
%bcond_without mead

%if %with mead
%bcond_with repolib
%else
%bcond_without repolib
%endif

%global apiname annotations
%global apiversion 1.1
%global apiversionu 1_1
%global plainversion %{meadversion}%{meadalpha}
%global apigroupid javax.annotation
%global apiartifactid %{apiname}-api

%define section free

%define maven_version 1.0.1.Final-redhat-2

Name:           jboss-%{apiname}-api_%{apiversion}_spec
Version:        %{meadversion}
Release:        %{serial}%{meadalpha}%{meadrel}%{?dist}
Epoch:          0
Summary:        Common Annotations 1.1 API
License:        LGPLv2+
URL:            http://fisheye.jboss.org/browse/JBossAS/projects/specs/tags/jboss-%{apiname}-api_%{apiversion}_spec-%{plainversion}
Group:          Development/Libraries/Java

%if %with mead
Source100: org.jboss.spec.javax.annotation-jboss-annotations-api_1.1_spec-1.0.1.Final-redhat-2-sources.zip
Source101: org.jboss.spec.javax.annotation-jboss-annotations-api_1.1_spec-1.0.1.Final-redhat-2-patches.zip
Source102: jboss-annotations-api_1.1_spec-1.0.1.Final-redhat-2.jar
Source103: jboss-annotations-api_1.1_spec-1.0.1.Final-redhat-2-javadoc.jar
Source104: jboss-annotations-api_1.1_spec-1.0.1.Final-redhat-2.pom
Source105: jboss-annotations-api_1.1_spec-1.0.1.Final-redhat-2-sources.jar
%endif

# svn export http://anonsvn.jboss.org/repos/jbossas/projects/specs/tags/jboss-annotations-api_1.1_spec-1.0.0.Final && tar cjf jboss-annotations-api_1.1_spec-1.0.0.Final.tar.bz2 jboss-annotations-api_1.1_spec-1.0.0.Final
# Exported revision 110833.
#Source0:        jboss-%{apiname}-api_%{apiversion}_spec-%{plainversion}.tar.bz2
#Source2:        jboss-%{apiname}-api_%{apiversion}_spec-jpp-depmap.xml
#Source3:        annotations-api-1.1.pom
#Patch0:         jboss-%{apiname}-api_%{apiversion}_spec-pom.patch
Provides:       %{apiname}_%{apiversionu}_api
Provides:       %{apiname}_api = 0:%{apiversion}
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
BuildRequires:       jpackage-utils
# Removed to avoid conflict on RHEL-7
#Requires:       jboss-specs-parent >= 1.0.0-0.1.Beta2
Requires:       servlet_3_0_api
%if %without mead
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven-project-info-reports-plugin
BuildRequires:  maven-skins
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  maven-surefire-report-plugin
BuildRequires:  mojo-maven2-plugin-taglist
BuildRequires:  jboss-parent
BuildRequires:  jboss-specs-parent >= 1.0.0-0.1.Beta2
BuildRequires:  jbossweb-servlet-2.5-api
%endif
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
The Common Annotations 1.1 API classes.

%if %with javadoc
%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%if 0
Requires(preun): %{_sbindir}/update-alternatives
Requires(post): %{_sbindir}/update-alternatives
%endif
Requires:       jpackage-utils

%description javadoc
%{summary}.
%endif

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java


%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%if %without mead
%setup -q -n jboss-%{apiname}-api_%{apiversion}_spec-%{plainversion}
%patch0 -p1 -b .sav0
%endif

%build
%if %without mead
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository
%{_bindir}/mvn-jpp \
        -e \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -DaltDeploymentRepository=oss-releases::default::file:maven2-brew \
        javadoc:javadoc javadoc:jar source:jar deploy site
%endif

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%if %without mead
pushd maven2-brew
%{__cp} -p org/jboss/spec/javax/xml/rpc/jboss-%{apiname}-api_%{apiversion}_spec/%{namedversion}/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}.jar %{buildroot}%{_javadir}
#%%{__cp} -p org/jboss/spec/javax/xml/rpc/jboss-%{apiname}-api_%{apiversion}_spec/%{namedversion}/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}-javadoc.jar %{buildroot}%{_javadir}
%{__cp} -p org/jboss/spec/javax/xml/rpc/jboss-%{apiname}-api_%{apiversion}_spec/%{namedversion}/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}-sources.jar %{buildroot}%{_javadir}
# poms
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%{__cp} -p org/jboss/spec/javax/xml/rpc/jboss-%{apiname}-api_%{apiversion}_spec/%{namedversion}/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-jboss-%{apiname}-api_%{apiversion}_spec.pom
popd
%else
%{__cp} -p %{_sourcedir}/%{name}-%{namedversion}.jar %{buildroot}%{_javadir}
#%%{__cp} -p %{_sourcedir}/%{name}-%{namedversion}-javadoc.jar %{buildroot}%{_javadir}
%{__cp} -p %{_sourcedir}/%{name}-%{namedversion}-sources.jar %{buildroot}%{_javadir}
# poms
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%{__cp} -p %{_sourcedir}/%{name}-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-jboss-%{apiname}-api_%{apiversion}_spec.pom
%endif
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done)

# depmaps
%add_to_maven_depmap org.jboss.spec.javax.annotation jboss-%{apiname}-api_%{apiversion}_spec %{namedversion} JPP jboss-%{apiname}-api_%{apiversion}_spec
%if 0
%add_to_maven_depmap %{apigroupid} %{apiartifactid} %{apiversion} JPP %{apiname}_%{apiversionu}_api
%else
%add_to_maven_depmap %{apigroupid} %{apiartifactid} %{apiversion} JPP jboss-%{apiname}-api_%{apiversion}_spec
%endif

%if %with javadoc
# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%if %without mead
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%else
%{__unzip} -qq %{_sourcedir}/%{name}-%{namedversion}-javadoc.jar -d %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__rm} -r %{buildroot}%{_javadocdir}/%{name}-%{namedversion}/META-INF
%endif
%{__ln_s} %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%if %without mead
%doc LICENSE, README
%endif
%dir %{_javadir}*
%{_javadir}*/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}.jar
%{_javadir}*/jboss-%{apiname}-api_%{apiversion}_spec.jar
#%{_javadir}*/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}-javadoc.jar
#%{_javadir}*/jboss-%{apiname}-api_%{apiversion}_spec-javadoc.jar
%{_javadir}*/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}-sources.jar
%{_javadir}*/jboss-%{apiname}-api_%{apiversion}_spec-sources.jar
%{_datadir}/maven2/poms/JPP-jboss-%{apiname}-api_%{apiversion}_spec.pom
%if 0
%ghost %{_datadir}/maven2/poms/JPP-%{apiname}_%{apiversionu}_api.pom
%ghost %{_datadir}/maven2/poms/JPP-%{apiname}_api.pom
%endif
%{_mavendepmapfragdir}/%{name}

%if %with javadoc
%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}
%if 0
%ghost %{_javadocdir}/%{apiname}_api
%ghost %{_javadocdir}/%{apiname}_%{apiversionu}_api
%endif
%endif

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%if %with javadoc
%exclude %dir %{_javadocdir}
%endif
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Mon Jul 21 2014 Fernando Nasser <fnasser@redhat.com> - 1.0.1-4.Final_redhat_2.2
- Removed dependency on specs parent to avoid conflict on RHEL-7
- Use new Version and Release macros
- Remove javadoc subpackage
- Must BR jpp-utils on RHEL-7

* Wed Sep 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.0.1-3.2.Final_redhat_2
- Rebuild for MD5

* Mon Aug 20 2012 Honza Brazdil <jbrazdil@redhat.com> - 0:1.0.1-2.2.Final_redhat_2
- Update pom patch for eap 6.0.1

* Fri Aug 10 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.0.1-2.1.Final_redhat_2.2
- Rebuild unsigned

* Thu Jul 12 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.0.1-2.1.Final_redhat_1.1
- Rebuild using cache signing

* Tue Jun 12 2012 David Walluck <dwalluck@redhat.com> 0:1.0.1-2.1
- generic maven depmap should point to an actual file
- remove update-alternatives requirement from javadoc package
- fix file list for main and javadoc packages

* Thu May 31 2012 Martha Benitez <mbenitez@redhat.com> - 0:1.0.1-2.Final_redhat_1
- Remove javadocs from main package and into their own RPM

* Thu May 03 2012 Hui Wang <huwang@redhat.com> 0:1.0.1-1.Final_redhat_1
- Upgrade to 1.0.1.Final

* Mon Apr 30 2012 Martha Benitez <mbenitez@redhat.com> - 0:1.0.0-6.Final_redhat_1
- Rebuild without mead.spec.tmpl
- Add ghost symlinks form pom.xml

* Thu Mar 15 2012 Hui Wang <huwang@redhat.com> 0:1.0.0-5.Final_redhat_1.1
- New wrapper
- Fix installing path
- Fix release tag

* Fri Jan 27 2012 Fernando Nasser <fnasser@redhat.com> 0:1.0.0-3
- Require Servlet 3.0 not 2.5
- Resign with new key

* Sun Jun 19 2011 Hui Wang <huwang@redhat.com> 0:1.0.0-2
- Adapt relocation pom as well
- Skip repolib creation if using MEAD

* Thu May 26 2011 Fernando Nasser <fnasser@redhat.com> 0:1.0.0-1
- Adapted from jboss-jaxrpc_1.1_spec
